<?php

class FCKeditorParser extends Parser
{
    public static $fkc_mw_makeImage_options;
    
    private $FCKeditorMagicWords = array(
    '__NOTOC__',
    '__FORCETOC__',
    '__NOEDITSECTION__',
    '__START__',
    '__NOTITLECONVERT__',
    '__NOCONTENTCONVERT__',
    '__END__',
    '__TOC__',
    '__NOTC__',
    '__NOCC__',
    "__FORCETOC__",
    "__NEWSECTIONLINK__",
    "__NOGALLERY__",
    );

    function replaceInternalLinks( $text ) {
        return parent::replaceInternalLinks($text);
    }
    function makeImage( $nt, $options ) {
        FCKeditorParser::$fkc_mw_makeImage_options = $options;
        return parent::makeImage( $nt, $options );
    }
    function internalParse ( $text ) {
        $callback = array('{' =>
        array(
        'end'=>'}',
        'cb' => array(
        2=>array('FCKeditorParser', 'leaveTemplatesAlone'),
        3=>array('FCKeditorParser', 'leaveTemplatesAlone'),
        ),
        'min' =>2,
        'max' =>3,
        )
        );

        $text = $this->replace_callback($text, $callback);

        $tags = array();
        $offset=0;
        $textTmp = $text;
        while (false !== ($pos = strpos($textTmp, "<!--FCK_SKIP_START-->")))
        {
            $tags[abs($pos + $offset)] = 1;
            $textTmp = substr($textTmp, $pos+21);
            $offset += $pos + 21;
        }

        $offset=0;
        $textTmp = $text;
        while (false !== ($pos = strpos($textTmp, "<!--FCK_SKIP_END-->")))
        {
            $tags[abs($pos + $offset)] = -1;
            $textTmp = substr($textTmp, $pos+19);
            $offset += $pos + 19;
        }

        if (!empty($tags)) {
            ksort($tags);

            $strtr = array("<!--FCK_SKIP_START-->" => "", "<!--FCK_SKIP_END-->" => "");

            $sum=0;
            $lastSum=0;
            $finalString = false;
            $startingPos = 0;
            $inner = "";
            foreach ($tags as $pos=>$type) {
                $sum += $type;
                if ($sum == 1 && $lastSum == 0) {
                    $finalString .= parent::internalParse(strtr(substr($text, $startingPos, $pos - $startingPos), $strtr));
                    $startingPos = $pos;
                }
                else if ($sum == 0) {
                    $finalString .= '<span class="fck_mw_template">' . htmlspecialchars(strtr(substr($text, $startingPos, $pos - $startingPos + 19), $strtr)) . '</span>';
                    $startingPos = $pos + 19;
                }
                $lastSum = $sum;
            }
            $finalString .= parent::internalParse(substr($text, $startingPos));
        } else {
            $finalString = parent::internalParse($text);
        }

        return $finalString;
    }
    function leaveTemplatesAlone( $matches ) {
        return "<!--FCK_SKIP_START-->".$matches['text']."<!--FCK_SKIP_END-->";
    }
    function formatHeadings( $text, $isMain=true ) {
        return $text;
    }
    function stripNoGallery($text) {}
    function stripToc( $text ) {
        //$prefix = '<span class="fck_mw_magic">';
        //$suffix = '</span>';
        $prefix = '';
        $suffix = '';

        $strtr = array();
        foreach ($this->FCKeditorMagicWords as $word) {
            $strtr[$word] = $prefix . $word . $suffix;
        }

        return strtr( $text, $strtr );
    }
    function strip( $text, $state, $stripcomments = false , $dontstrip = array () ) {
        $dontstrip[] = "gallery";

        return parent::strip($text, $state, $stripcomments , $dontstrip );
    }
    /**
	* Callback function for <ref>
	*
	* @param string $str Input
	* @param array $argv Arguments
	* @return string
	*/
    function ref( $str, $argv, $parser ) {
        if (empty($argv)) {
			$ret = "<span class=\"fck_mw_ref\">";
        }
        else {
			$ret = "<span class=\"fck_mw_ref\"";
            foreach ($argv as $key=>$value) {
                $ret .= " ".$key."=\"".$value."\"";
            }
            $ret .=">";
        }
        if (is_null($str)) {
            $ret = substr($ret, 0, -1) . " />";
        }
        else {
            $ret .= htmlspecialchars($str);
            $ret .= "</span>";
        }
        return $ret;
    }
    /**
	* Callback function for <references>
	*
	* @param string $str Input
	* @param array $argv Arguments
	* @return string
	*/
    function references( $str, $argv, $parser ) {
        if (empty($argv)) {
			$ret = "<span class=\"fck_mw_references\">";
        }
        else {
			$ret = "<span class=\"fck_mw_references\"";
            foreach ($argv as $key=>$value) {
                $ret .= " ".$key."=\"".$value."\"";
            }
            $ret .=">";
        }
        if (is_null($str)) {
            $ret = substr($ret, 0, -1) . " />";
        }
        else {
            $ret .= htmlspecialchars($str);
            $ret .= "</span>";
        }

        return $ret;
    }

    function parse( $text, &$title, $options, $linestart = true, $clearState = true, $revid = null ) {
        $parserOutput = parent::parse($text, &$title, $options, $linestart , $clearState , $revid );
        
        $categories = $parserOutput->getCategories();
        if ($categories) {
            $appendString = "";
            foreach ($categories as $cat=>$val) {
                $appendString .= "<a href=\"Category:" . $cat ."\">Category:" . $cat ."</a> ";
            }
            $parserOutput->setText($parserOutput->getText() . $appendString);
        }                
        
        return $parserOutput;
    }
    
    /*
    function replaceVariables( $text, $args = array(), $argsOnly = false ) {
    return preg_replace("/\{\{([^}]+)\}\}(\}*)/", '<span class="fck_template">{{$1}}$2</span>', $text);
    }
    */
}
